Package org.bukkit.entity

# Interface Arrow

All Superinterfaces:
  `AbstractArrow`, `Audience`, `CommandSender`, `Entity`, `HoverEventSource<HoverEvent.ShowEntity>`, `Metadatable`, `Nameable`, `Permissible`, `PersistentDataHolder`, `Pointered`, `Projectile`, `ServerOperator`, `Sound.Emitter`

All Known Subinterfaces:
  `TippedArrow`

public interface Arrow extends AbstractArrow

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.bukkit.entity.AbstractArrow

`AbstractArrow.PickupRule, AbstractArrow.PickupStatus`

## Nested classes/interfaces inherited from interface org.bukkit.entity.Entity

`Entity.Spigot`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`addCustomEffect(@NotNull PotionEffect effect, boolean overwrite)`
Adds a custom potion effect to this arrow.
`void`
`clearCustomEffects()`
Removes all custom potion effects from this arrow.
`@NotNull PotionData`
`getBasePotionData()`
Returns the potion data about the base potion
`@Nullable Color`
`getColor()`
Gets the color of this arrow.
`@NotNull List<PotionEffect>`
`getCustomEffects()`
Gets an immutable list containing all custom potion effects applied to this arrow.
`boolean`
`hasCustomEffect(@Nullable PotionEffectType type)`
Checks for a specific custom potion effect type on this arrow.
`boolean`
`hasCustomEffects()`
Checks for the presence of custom potion effects.
`boolean`
`removeCustomEffect(@NotNull PotionEffectType type)`
Removes a custom potion effect from this arrow.
`void`
`setBasePotionData(@NotNull PotionData data)`
Sets the underlying potion data
`void`
`setColor(@Nullable Color color)`
Sets the color of this arrow.

### Methods inherited from interface org.bukkit.entity.AbstractArrow

`getAttachedBlock, getDamage, getItemStack, getKnockbackStrength, getPickupRule, getPickupStatus, getPierceLevel, hasNoPhysics, isCritical, isInBlock, isShotFromCrossbow, setCritical, setDamage, setKnockbackStrength, setNoPhysics, setPickupRule, setPickupStatus, setPierceLevel, setShotFromCrossbow`

### Methods inherited from interface net.kyori.adventure.audience.Audience

`clearTitle, filterAudience, forEachAudience, hideBossBar, openBook, openBook, playSound, playSound, playSound, resetTitle, sendActionBar, sendActionBar, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendPlayerListFooter, sendPlayerListFooter, sendPlayerListHeader, sendPlayerListHeader, sendPlayerListHeaderAndFooter, sendPlayerListHeaderAndFooter, sendTitlePart, showBossBar, showTitle, stopSound, stopSound`

### Methods inherited from interface org.bukkit.command.CommandSender

`getName, name, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage`

### Methods inherited from interface org.bukkit.entity.Entity

`addPassenger, addScoreboardTag, asHoverEvent, eject, fromMobSpawner, getBoundingBox, getChunk, getEntityId, getEntitySpawnReason, getFacing, getFallDistance, getFireTicks, getFreezeTicks, getHeight, getLastDamageCause, getLocation, getLocation, getMaxFireTicks, getMaxFreezeTicks, getNearbyEntities, getOrigin, getPassenger, getPassengers, getPistonMoveReaction, getPortalCooldown, getPose, getScoreboardTags, getServer, getSpawnCategory, getTicksLived, getTrackedPlayers, getType, getUniqueId, getVehicle, getVelocity, getWidth, getWorld, hasGravity, isCustomNameVisible, isDead, isEmpty, isFreezeTickingLocked, isFrozen, isGlowing, isInBubbleColumn, isInLava, isInPowderedSnow, isInRain, isInsideVehicle, isInvulnerable, isInWater, isInWaterOrBubbleColumn, isInWaterOrRain, isInWaterOrRainOrBubbleColumn, isOnGround, isPersistent, isSilent, isTicking, isValid, isVisualFire, leaveVehicle, lockFreezeTicks, playEffect, remove, removePassenger, removeScoreboardTag, setCustomNameVisible, setFallDistance, setFireTicks, setFreezeTicks, setGlowing, setGravity, setInvulnerable, setLastDamageCause, setPassenger, setPersistent, setPortalCooldown, setRotation, setSilent, setTicksLived, setVelocity, setVisualFire, spawnAt, spawnAt, spigot, teamDisplayName, teleport, teleport, teleport, teleport, teleportAsync, teleportAsync`

### Methods inherited from interface net.kyori.adventure.text.event.HoverEventSource

`asHoverEvent`

### Methods inherited from interface org.bukkit.metadata.Metadatable

`getMetadata, hasMetadata, removeMetadata, setMetadata`

### Methods inherited from interface org.bukkit.Nameable

`customName, customName, getCustomName, setCustomName`

### Methods inherited from interface org.bukkit.permissions.Permissible

`addAttachment, addAttachment, addAttachment, addAttachment, getEffectivePermissions, hasPermission, hasPermission, isPermissionSet, isPermissionSet, permissionValue, permissionValue, recalculatePermissions, removeAttachment`

### Methods inherited from interface org.bukkit.persistence.PersistentDataHolder

`getPersistentDataContainer`

### Methods inherited from interface net.kyori.adventure.pointer.Pointered

`get, getOrDefault, getOrDefaultFrom, pointers`

### Methods inherited from interface org.bukkit.entity.Projectile

`doesBounce, getShooter, setBounce, setShooter`

### Methods inherited from interface org.bukkit.permissions.ServerOperator

`isOp, setOp`

## Method Details

### setBasePotionData

void setBasePotionData(@NotNull @NotNull PotionData data)
Sets the underlying potion data

Parameters:
  `data` - PotionData to set the base potion state to

### getBasePotionData

@NotNull @NotNull PotionData getBasePotionData()
Returns the potion data about the base potion

Returns:
  a PotionData object

### getColor

@Nullable @Nullable Color getColor()
Gets the color of this arrow.

Returns:
  arrow `Color` or null if not color is set

### setColor

void setColor(@Nullable @Nullable Color color)
Sets the color of this arrow. Will be applied as a tint to its particles.

Parameters:
  `color` - arrow color, null to clear the color

### hasCustomEffects

boolean hasCustomEffects()
Checks for the presence of custom potion effects.

Returns:
  true if custom potion effects are applied

### getCustomEffects

@NotNull @NotNull List<PotionEffect> getCustomEffects()
Gets an immutable list containing all custom potion effects applied to this arrow.

Plugins should check that hasCustomEffects() returns true before calling this method.

Returns:
  the immutable list of custom potion effects

### addCustomEffect

boolean addCustomEffect(@NotNull @NotNull PotionEffect effect, boolean overwrite)
Adds a custom potion effect to this arrow.

Parameters:
  `effect` - the potion effect to add
  `overwrite` - true if any existing effect of the same type should be overwritten
Returns:
  true if the effect was added as a result of this call

### removeCustomEffect

boolean removeCustomEffect(@NotNull @NotNull PotionEffectType type)
Removes a custom potion effect from this arrow.

Parameters:
  `type` - the potion effect type to remove
Returns:
  true if the an effect was removed as a result of this call
Throws:
  `IllegalArgumentException` - if this operation would leave the Arrow in a state with no Custom Effects and PotionType.UNCRAFTABLE

### hasCustomEffect

boolean hasCustomEffect(@Nullable @Nullable PotionEffectType type)
Checks for a specific custom potion effect type on this arrow.

Parameters:
  `type` - the potion effect type to check for
Returns:
  true if the potion has this effect

### clearCustomEffects

void clearCustomEffects()
Removes all custom potion effects from this arrow.

Throws:
  `IllegalArgumentException` - if this operation would leave the Arrow in a state with no Custom Effects and PotionType.UNCRAFTABLE